---
title: InstallEvent
slug: Web/API/InstallEvent
tags:
  - API
  - InstallEvent
  - Interface
  - Offline
  - Reference
  - Service Workers
  - Service worker API
  - ServiceWorker
  - Workers
---
<div>{{non-standard_header}}{{obsolete_header}}</div>

<p><span class="seoSummary">The parameter passed into the {{domxref("ServiceWorkerGlobalScope.oninstall", "oninstall")}} handler, the <code>InstallEvent</code> interface represents an install action that is dispatched on the {{domxref("ServiceWorkerGlobalScope")}} of a {{domxref("ServiceWorker")}}. As a child of {{domxref("ExtendableEvent")}}, it ensures that functional events such as {{domxref("FetchEvent")}} are not dispatched during installation. </span></p>

<p>This interface inherits from the {{domxref("ExtendableEvent")}} interface.</p>

<p>{{InheritanceDiagram(700, 60, 20)}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("InstallEvent.InstallEvent()")}}</dt>
 <dd>Creates a new <code>InstallEvent</code> object.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its ancestor, {{domxref("Event")}}</em>.</p>

<dl>
 <dt>{{domxref("InstallEvent.activeWorker")}} {{readonlyInline}}</dt>
 <dd>Returns the {{domxref("ServiceWorker")}} that is currently controlling the page.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, </em><em>{{domxref("ExtendableEvent")}}</em>.</p>

<h2 id="Examples">Examples</h2>

<p>This code snippet is from the <a href="https://github.com/GoogleChrome/samples/blob/gh-pages/service-worker/prefetch/service-worker.js">service worker prefetch sample</a> (see <a href="https://googlechrome.github.io/samples/service-worker/prefetch/">prefetch running live</a>.) The code calls {{domxref("ExtendableEvent.waitUntil", "ExtendableEvent.waitUntil()")}} in {{domxref("ServiceWorkerGlobalScope.oninstall")}} and delays treating the {{domxref("ServiceWorkerRegistration.installing")}} worker as installed until the passed promise resolves successfully. The promise resolves when all resources have been fetched and cached, or when any exception occurs.</p>

<p>The code snippet also shows a best practice for versioning caches used by the service worker. Although this example has only one cache, you can use this approach for multiple caches. The code maps a shorthand identifier for a cache to a specific, versioned cache name.</p>

<div class="note">
<p><strong>Note</strong>: Logging statements are visible in Google Chrome via the "Inspect" interface for the relevant service worker accessed via chrome://serviceworker-internals.</p>
</div>

<pre class="brush: js notranslate">var CACHE_VERSION = 1;
var CURRENT_CACHES = {
  prefetch: 'prefetch-cache-v' + CACHE_VERSION
};

self.addEventListener('install', function(event) {
  var urlsToPrefetch = [
    './static/pre_fetched.txt',
    './static/pre_fetched.html',
    'https://www.chromium.org/_/rsrc/1302286216006/config/customLogo.gif'
  ];

console.log('Handling install event. Resources to pre-fetch:', urlsToPrefetch);

  event.waitUntil(
    caches.open(CURRENT_CACHES['prefetch']).then(function(cache) {
      return cache.addAll(urlsToPrefetch.map(function(urlToPrefetch) {
        return new Request(urlToPrefetch, {mode: 'no-cors'});
      })).then(function() {
        console.log('All resources have been fetched and cached.');
      });
    }).catch(function(error) {
      console.error('Pre-fetching failed:', error);
    })
  );
});</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.InstallEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("NotificationEvent")}}</li>
 <li>{{jsxref("Promise")}}</li>
 <li><a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a></li>
</ul>
